# Class VulkanPipelineVertexInputStateCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanPipelineVertexInputStateCreateInfo

All Implemented Interfaces:
  `VulkanPipelineVertexInputStateCreateInfoType`

public final class VulkanPipelineVertexInputStateCreateInfo extends Object implements VulkanPipelineVertexInputStateCreateInfoType

See Also:
  - "VkPipelineVertexInputStateCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanPipelineVertexInputStateCreateInfo.Builder`
  Builds instances of type `VulkanPipelineVertexInputStateCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanPipelineVertexInputStateCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanPipelineVertexInputStateCreateInfo`.
  `static VulkanPipelineVertexInputStateCreateInfo`
  `copyOf(VulkanPipelineVertexInputStateCreateInfoType instance)`
  Creates an immutable copy of a `VulkanPipelineVertexInputStateCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanPipelineVertexInputStateCreateInfo` that have equal attribute values.
  `Set<VulkanPipelineVertexInputStateCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `vertexBindingDescriptions`, `vertexAttributeDescriptions`.
  `static VulkanPipelineVertexInputStateCreateInfo`
  `of(Iterable<VulkanPipelineVertexInputStateCreateFlag> flags, Iterable<? extends VulkanVertexInputBindingDescription> vertexBindingDescriptions, Iterable<? extends VulkanVertexInputAttributeDescription> vertexAttributeDescriptions)`
  Construct a new immutable `VulkanPipelineVertexInputStateCreateInfo` instance.
  `static VulkanPipelineVertexInputStateCreateInfo`
  `of(Set<VulkanPipelineVertexInputStateCreateFlag> flags, List<VulkanVertexInputBindingDescription> vertexBindingDescriptions, List<VulkanVertexInputAttributeDescription> vertexAttributeDescriptions)`
  Construct a new immutable `VulkanPipelineVertexInputStateCreateInfo` instance.
  `String`
  `toString()`
  Prints the immutable value `VulkanPipelineVertexInputStateCreateInfo` with attribute values.
  `List<VulkanVertexInputAttributeDescription>`
  `vertexAttributeDescriptions()`
  `List<VulkanVertexInputBindingDescription>`
  `vertexBindingDescriptions()`
  `final VulkanPipelineVertexInputStateCreateInfo`
  `withFlags(VulkanPipelineVertexInputStateCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineVertexInputStateCreateInfo`
  `withFlags(Iterable<VulkanPipelineVertexInputStateCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineVertexInputStateCreateInfo`
  `withVertexAttributeDescriptions(VulkanVertexInputAttributeDescription... elements)`
  Copy the current immutable object with elements that replace the content of `vertexAttributeDescriptions`.
  `final VulkanPipelineVertexInputStateCreateInfo`
  `withVertexAttributeDescriptions(Iterable<? extends VulkanVertexInputAttributeDescription> elements)`
  Copy the current immutable object with elements that replace the content of `vertexAttributeDescriptions`.
  `final VulkanPipelineVertexInputStateCreateInfo`
  `withVertexBindingDescriptions(VulkanVertexInputBindingDescription... elements)`
  Copy the current immutable object with elements that replace the content of `vertexBindingDescriptions`.
  `final VulkanPipelineVertexInputStateCreateInfo`
  `withVertexBindingDescriptions(Iterable<? extends VulkanVertexInputBindingDescription> elements)`
  Copy the current immutable object with elements that replace the content of `vertexBindingDescriptions`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanPipelineVertexInputStateCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanPipelineVertexInputStateCreateInfoType`
    Returns:
      Flags reserved for future use

  - ### vertexBindingDescriptions

    public List<VulkanVertexInputBindingDescription> vertexBindingDescriptions()
    Specified by:
      `vertexBindingDescriptions` in interface `VulkanPipelineVertexInputStateCreateInfoType`
    Returns:
      The binding descriptions

  - ### vertexAttributeDescriptions

    public List<VulkanVertexInputAttributeDescription> vertexAttributeDescriptions()
    Specified by:
      `vertexAttributeDescriptions` in interface `VulkanPipelineVertexInputStateCreateInfoType`
    Returns:
      The attribute descriptions

  - ### withFlags

    public final VulkanPipelineVertexInputStateCreateInfo withFlags(VulkanPipelineVertexInputStateCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanPipelineVertexInputStateCreateInfo withFlags(Iterable<VulkanPipelineVertexInputStateCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withVertexBindingDescriptions

    public final VulkanPipelineVertexInputStateCreateInfo withVertexBindingDescriptions(VulkanVertexInputBindingDescription... elements)
    Copy the current immutable object with elements that replace the content of `vertexBindingDescriptions`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withVertexBindingDescriptions

    public final VulkanPipelineVertexInputStateCreateInfo withVertexBindingDescriptions(Iterable<? extends VulkanVertexInputBindingDescription> elements)
    Copy the current immutable object with elements that replace the content of `vertexBindingDescriptions`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of vertexBindingDescriptions elements to set
    Returns:
      A modified copy of `this` object

  - ### withVertexAttributeDescriptions

    public final VulkanPipelineVertexInputStateCreateInfo withVertexAttributeDescriptions(VulkanVertexInputAttributeDescription... elements)
    Copy the current immutable object with elements that replace the content of `vertexAttributeDescriptions`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withVertexAttributeDescriptions

    public final VulkanPipelineVertexInputStateCreateInfo withVertexAttributeDescriptions(Iterable<? extends VulkanVertexInputAttributeDescription> elements)
    Copy the current immutable object with elements that replace the content of `vertexAttributeDescriptions`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of vertexAttributeDescriptions elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanPipelineVertexInputStateCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `vertexBindingDescriptions`, `vertexAttributeDescriptions`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanPipelineVertexInputStateCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanPipelineVertexInputStateCreateInfo of(Set<VulkanPipelineVertexInputStateCreateFlag> flags, List<VulkanVertexInputBindingDescription> vertexBindingDescriptions, List<VulkanVertexInputAttributeDescription> vertexAttributeDescriptions)
    Construct a new immutable `VulkanPipelineVertexInputStateCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `vertexBindingDescriptions` - The value for the `vertexBindingDescriptions` attribute
      `vertexAttributeDescriptions` - The value for the `vertexAttributeDescriptions` attribute
    Returns:
      An immutable VulkanPipelineVertexInputStateCreateInfo instance

  - ### of

    public static VulkanPipelineVertexInputStateCreateInfo of(Iterable<VulkanPipelineVertexInputStateCreateFlag> flags, Iterable<? extends VulkanVertexInputBindingDescription> vertexBindingDescriptions, Iterable<? extends VulkanVertexInputAttributeDescription> vertexAttributeDescriptions)
    Construct a new immutable `VulkanPipelineVertexInputStateCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `vertexBindingDescriptions` - The value for the `vertexBindingDescriptions` attribute
      `vertexAttributeDescriptions` - The value for the `vertexAttributeDescriptions` attribute
    Returns:
      An immutable VulkanPipelineVertexInputStateCreateInfo instance

  - ### copyOf

    public static VulkanPipelineVertexInputStateCreateInfo copyOf(VulkanPipelineVertexInputStateCreateInfoType instance)
    Creates an immutable copy of a `VulkanPipelineVertexInputStateCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanPipelineVertexInputStateCreateInfo instance

  - ### builder

    public static VulkanPipelineVertexInputStateCreateInfo.Builder builder()
    Creates a builder for `VulkanPipelineVertexInputStateCreateInfo`.

         VulkanPipelineVertexInputStateCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanPipelineVertexInputStateCreateFlag) // flags elements
            .addVertexBindingDescriptions|addAllVertexBindingDescriptions(VulkanVertexInputBindingDescription) // vertexBindingDescriptions elements
            .addVertexAttributeDescriptions|addAllVertexAttributeDescriptions(VulkanVertexInputAttributeDescription) // vertexAttributeDescriptions elements
            .build();

    Returns:
      A new VulkanPipelineVertexInputStateCreateInfo builder